searchNodes=[{"doc":"This module contains functions and types related to audit logs.","ref":"Alchemy.AuditLog.html","title":"Alchemy.AuditLog","type":"module"},{"doc":"Returns an audit log entry for a guild.Requires :view_audit_log permission.Optionsuser_id Filters the log for a user id.action_type The type of audit log eventbefore Filter the log before a certain entry id.limit How many entries are returned (default 50, between 1 and 100).","ref":"Alchemy.AuditLog.html#get_guild_log/2","title":"Alchemy.AuditLog.get_guild_log/2","type":"function"},{"doc":"An enumeration of action types.","ref":"Alchemy.AuditLog.html#t:action/0","title":"Alchemy.AuditLog.action/0","type":"type"},{"doc":"The type of an audit log change.new_value The new value after the change.old_value The value prior to the change.key The type of change that occurred. This also dictates the type of new_value and old_valuemore information on this relation","ref":"Alchemy.AuditLog.html#t:change/0","title":"Alchemy.AuditLog.change/0","type":"type"},{"doc":"An entry in an audit log.target_id The id of the affected entity.changes The changes made to the target_id.user_id The user who made the changes.id The id of the entryaction_type The type of action that occurredoptions Additional map of information for certain action types.reason The reason for the change","ref":"Alchemy.AuditLog.html#t:entry/0","title":"Alchemy.AuditLog.entry/0","type":"type"},{"doc":"Additional information fields in an audit log based on action_type.:member_prune -&gt; [:delete_member_days, :members_removed] :message_delete -&gt; [:channel_id, :count] :channel_overwrite_create | delete | update -&gt; [:id, :type, :role_name]","ref":"Alchemy.AuditLog.html#t:options/0","title":"Alchemy.AuditLog.options/0","type":"type"},{"doc":"","ref":"Alchemy.AuditLog.html#t:snowflake/0","title":"Alchemy.AuditLog.snowflake/0","type":"type"},{"doc":"Represents the Audit Log information of a guild.webhooks List of webhooks found in the Audit Log.user List of users found in the Audit Log.audit_log_entries List of entries in the Audit Log.","ref":"Alchemy.AuditLog.html#t:t/0","title":"Alchemy.AuditLog.t/0","type":"type"},{"doc":"This module provides a handful of useful functions to interact with the cache.By default, Alchemy caches a great deal of information given to it, notably about guilds. In general, using the cache should be prioritised over using the api functions in Alchemy.Client. However, a lot of struct modules have &quot;smart&quot; functions that will correctly balance the cache and the api, as well as use macros to get information from the context of commands.","ref":"Alchemy.Cache.html","title":"Alchemy.Cache","type":"module"},{"doc":"Retrieves a specific channel in a guild.","ref":"Alchemy.Cache.html#channel/2","title":"Alchemy.Cache.channel/2","type":"function"},{"doc":"Retrieves a custom emoji by id in a guild.","ref":"Alchemy.Cache.html#emoji/2","title":"Alchemy.Cache.emoji/2","type":"function"},{"doc":"Fetches a guild from the cache by a given id.By default, this method needs the guild_id, but keywords can be used to specify a different id, and use the appropiate paths to get the guild using that.In general there are &quot;smarter&quot; methods, that will deal with getting the id for you; nonetheless, the need for this function sometimes exists.Keywordschannel Using this keyword will fetch the information for the guild a channel belongs to.","ref":"Alchemy.Cache.html#guild/1","title":"Alchemy.Cache.guild/1","type":"function"},{"doc":"Gets the corresponding guild_id for a channel.In case the channel guild can't be found, :none will be returned.This is useful when the guild_id is needed for some kind of task, but there's no need for getting the whole struct. Because of how the registry is set up, getting the entire guild requires a whole extra step, that passes through this one anyways.","ref":"Alchemy.Cache.html#guild_id/1","title":"Alchemy.Cache.guild_id/1","type":"function"},{"doc":"Requests the loading of offline guild members for a guild.Guilds should automatically get 250 offline members after the :ready event, however, you can use this method to request a fuller list if needed.The username is used to only select members whose username starts with a certain string; &quot;&quot; won't do any filtering. The limit specifies the amount of members to get; 0 for unlimited.There's a ratelimit of ~100 requests per shard per minute on this function, so be wary of the fact that this might block a process.","ref":"Alchemy.Cache.html#load_guild_members/3","title":"Alchemy.Cache.load_guild_members/3","type":"function"},{"doc":"Gets a member from a cache, by guild and member id.","ref":"Alchemy.Cache.html#member/2","title":"Alchemy.Cache.member/2","type":"function"},{"doc":"Gets the presence of a user in a certain guild.This contains info such as their status, and roles.","ref":"Alchemy.Cache.html#presence/2","title":"Alchemy.Cache.presence/2","type":"function"},{"doc":"Fetches a private_channel in the cache by id of the channel.Takes a DMChannel id. Alternatively, user: user_id can be passed to find the private channel related to a user.","ref":"Alchemy.Cache.html#private_channel/1","title":"Alchemy.Cache.private_channel/1","type":"function"},{"doc":"Gets a specific role in a guild.","ref":"Alchemy.Cache.html#role/2","title":"Alchemy.Cache.role/2","type":"function"},{"doc":"Searches across all guild for information.The section is the type of object to search for. The possibilities are: :guilds, :members, :roles, :presences, :voice_states, :emojis, :channelsThe filter is a function returning a boolean, that allows you to filter out elements from this list.The return type will be a struct of the same type of the section searched for.ExamplesCache.search(:members, fn x -&gt; String.length(x.nick) &lt; 10 end)This will return a list of all members whose nickname is less than 10 characters long.Cache.search(:roles, &amp;match?(%{name: &quot;Cool Kids&quot;}, &amp;1))This is a good example of using the match?/2 function to filter against a pattern.Cache.search(:guilds, &amp;match?(%{name: &quot;Test&quot;}, &amp;1))Will match any guilds named &quot;Test&quot; in the cache.","ref":"Alchemy.Cache.html#search/2","title":"Alchemy.Cache.search/2","type":"function"},{"doc":"Gets the user struct for this client from the cache.ExamplesCogs.def hello do Cogs.say &quot;hello, my name is \#{Cache.user().name}&quot; end","ref":"Alchemy.Cache.html#user/0","title":"Alchemy.Cache.user/0","type":"function"},{"doc":"Retrieves a user's voice state by id in a guild.","ref":"Alchemy.Cache.html#voice_state/2","title":"Alchemy.Cache.voice_state/2","type":"function"},{"doc":"","ref":"Alchemy.Cache.html#t:snowflake/0","title":"Alchemy.Cache.snowflake/0","type":"type"},{"doc":"This module contains useful functions for operating on Channels.","ref":"Alchemy.Channel.html","title":"Alchemy.Channel","type":"module"},{"doc":"Represents a channel category in a guild.idThe id of this categoryguild_idThe of the guild this category belongs topositionThe sorting position of this categorypermission_overwritesAn array of permission overwritesnameThe name of this categorynsfwWhether or not this category is considered nsfw","ref":"Alchemy.Channel.html#t:channel_category/0","title":"Alchemy.Channel.channel_category/0","type":"type"},{"doc":"","ref":"Alchemy.Channel.html#t:datetime/0","title":"Alchemy.Channel.datetime/0","type":"type"},{"doc":"Represents a private message between the bot and another user.idThe id of this channelrecipientsA list of users receiving this channellast_message_idThe id of the last message sent, if any","ref":"Alchemy.Channel.html#t:dm_channel/0","title":"Alchemy.Channel.dm_channel/0","type":"type"},{"doc":"Represents a dm channel between multiple users.idThe id of this channelowner_idThe id of the owner of this channeliconThe hash of the image icon for this channel, if it has onenameThe name of this channelrecipientsA list of recipients of this channellast_message_id The id of the last message sent in this channel, if any","ref":"Alchemy.Channel.html#t:group_dm_channel/0","title":"Alchemy.Channel.group_dm_channel/0","type":"type"},{"doc":"","ref":"Alchemy.Channel.html#t:hash/0","title":"Alchemy.Channel.hash/0","type":"type"},{"doc":"Represents an Invite object along with the metadata.codeThe unique invite codeguildThe guild this invite is forchannelThe channel this invite is forinviterThe user who created the inviteusesThe amount of time this invite has been usedmax_usesThe max number of times this invite can be usedmax_ageThe duration (seconds) after which the invite will expiretemporaryWhether this invite grants temporary membershipcreated_atWhen this invite was createdrevokedWhether this invite was revoked","ref":"Alchemy.Channel.html#t:invite/0","title":"Alchemy.Channel.invite/0","type":"type"},{"doc":"Represents the channel an invite is foridThe id of the channelnameThe name of the channeltypeThe type of the channel, either &quot;text&quot; or &quot;voice&quot;","ref":"Alchemy.Channel.html#t:invite_channel/0","title":"Alchemy.Channel.invite_channel/0","type":"type"},{"doc":"Represents the guild an invite is for.idThe id of the guildnameThe name of the guildsplashThe hash of the guild splash (or nil)iconThe hash of the guild icon (or nil)","ref":"Alchemy.Channel.html#t:invite_guild/0","title":"Alchemy.Channel.invite_guild/0","type":"type"},{"doc":"Represents a permission OverWrite objectidrole or user idtypeeither &quot;role&quot;, or &quot;member&quot;allowthe bit set of that permissiondenythe bit set of that permission","ref":"Alchemy.Channel.html#t:overwrite/0","title":"Alchemy.Channel.overwrite/0","type":"type"},{"doc":"","ref":"Alchemy.Channel.html#t:snowflake/0","title":"Alchemy.Channel.snowflake/0","type":"type"},{"doc":"The general channel type, representing one of 5 variants.The best way of dealing with this type is pattern matching against one of the 5 structs.","ref":"Alchemy.Channel.html#t:t/0","title":"Alchemy.Channel.t/0","type":"type"},{"doc":"Represents a normal text channel in a guild_ id The id of the channelguild_idThe id of the guild this channel belongs topositionThe sorting position of this channelpermission_overwritesAn array of %OverWrite{} structsnameThe name of this channeltopicThe topic of the channelnsfwWhether or not the channel is considered nsfwlast_message_idThe id of the last message sent in the channel, if anyparent_idThe id of the category this channel belongs to, if anylast_pin_timestampThe timestamp of the last channel pin, if any","ref":"Alchemy.Channel.html#t:text_channel/0","title":"Alchemy.Channel.text_channel/0","type":"type"},{"doc":"Represents a voice channel in a guild.idThe id of this channelguild_idThe id of the guild this channel belongs topositionThe sorting position of this channel in the guildpermission_overwritesAn array of permission overwrites for this channelnameThe name of this channelnsfwWhether or not this channel is considered nsfwbitrateThe bitrate for this channeluser_limitThe max amount of users in this channel, 0 for no limitparent_idThe id of the category this channel belongs to, if any","ref":"Alchemy.Channel.html#t:voice_channel/0","title":"Alchemy.Channel.voice_channel/0","type":"type"},{"doc":"Represents a Client connection to the Discord API. This is the main public interface for the REST API.As you might have seen in other examples, this module is the main entry point for Alchemy. start/2 will start up the necessary modules and caches necessary to hook into discord. You generally want to do this before you do any other work in your bot really.BlockingAll the requests here will block the process using them. Since all the event handles and commands created with this framework run in concurrent processes, this isn't usually an issue. If you do want to &quot;fire and forget&quot;, it's easy to wrap these requests in a task.CachingIn general, you should try and use the functions provided by Alchemy.Cache over the requests in this module, because the cache functions will be much faster, and avoid excess API requests.","ref":"Alchemy.Client.html","title":"Alchemy.Client","type":"module"},{"doc":"Adds a reaction to a message.This supports sending either a custom emoji object, or a unicode literal. While sending raw unicode is technically possible, you'll usually run into url encoding issues due to hidden characters if you try to send something like &quot;❤️️&quot;; use \\u2764 instead.ExamplesCogs.def heart do Client.add_reaction(message, &quot;️\\u2764&quot;) end","ref":"Alchemy.Client.html#add_reaction/2","title":"Alchemy.Client.add_reaction/2","type":"function"},{"doc":"Adds a role to a member of a guild.Requires the :manage_roles permission.ExamplesClient.add_role(guild_id, user_id, role_id)","ref":"Alchemy.Client.html#add_role/3","title":"Alchemy.Client.add_role/3","type":"function"},{"doc":"Bans a member from a guild.This prevents a user from rejoining for as long as the ban persists, as opposed to kick_member/2 which will just make them leave the server.A days paramater can be set to delete x days of messages; limited to 7.ExamplesClient.ban_member(guild_id, user_id, 1)","ref":"Alchemy.Client.html#ban_member/3","title":"Alchemy.Client.ban_member/3","type":"function"},{"doc":"Modifies the nickname of the current user.ExamplesClient.change_nickname(guild_id, &quot;best bot&quot;)","ref":"Alchemy.Client.html#change_nickname/2","title":"Alchemy.Client.change_nickname/2","type":"function"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"Alchemy.Client.html#child_spec/1","title":"Alchemy.Client.child_spec/1","type":"function"},{"doc":"Opens a new private channel with a user.ExamplesCogs.def dm_me do Client.create_DM(message.author.id) end","ref":"Alchemy.Client.html#create_DM/1","title":"Alchemy.Client.create_DM/1","type":"function"},{"doc":"Creates a new channel in a guild.Requires the MANAGE_CHANNELS permission.Optionsvoice Setting this creates a new voice channel.bitrate Sets the bitrate (bits) for a voice channel.user_limit Sets the max amount of users for a voice channel.permission_overwrites An overwrite for permissions in that channelExamplesClient.create_channel(guild_id)","ref":"Alchemy.Client.html#create_channel/3","title":"Alchemy.Client.create_channel/3","type":"function"},{"doc":"Creates a new invite for a channel.Requires the CREATE_INSTANT_INVITE permission.Optionsmax_ageThe duration (seconds) of the invite. 0 for never.max_usesThe max number of uses. 0 for unlimited.temporaryWhether this invite grants temporary membership.uniqueWhen set, a similar invite won't try to be used. Useful for creating unique one time use invites.ExamplesCogs.def invite do {:ok, invite} = Client.create_invite(message.channel_id, max_age: 0) Cogs.say(&quot;Here you go:\\nhttps://discord.gg/\#{invite.code}&quot;) end","ref":"Alchemy.Client.html#create_invite/2","title":"Alchemy.Client.create_invite/2","type":"function"},{"doc":"Creates a new role in the guild.Requires the :manage_roles permission.Optionsname The name of the new role. Defaults to &quot;new role&quot;permissions The set of permissions for that role. Defaults to the @everyone permissions in that guild.color The color of the role. Defaults to 0x000000hoist When set to true, the role will be displayed seperately in the sidebar.mentionable When set to true, allows the role to be mentioned.ExamplesClient.create_role(guild_id, name: &quot;the best role&quot;, color: 0x4bd1be)","ref":"Alchemy.Client.html#create_role/2","title":"Alchemy.Client.create_role/2","type":"function"},{"doc":"Deletes a channel from a guild.Here's an example of how to deal with the possible return types using pattern matching:def my_delete(id) do {:ok, channel} = Client.delete_channel(id) case channel do %DMChannel{} -&gt; &quot;this is a private channel!&quot; %TextChannel{} -&gt; &quot;this is a normal channel!&quot; end end","ref":"Alchemy.Client.html#delete_channel/1","title":"Alchemy.Client.delete_channel/1","type":"function"},{"doc":"Removes an integration from a guild.Requires the :manage_guild permission.","ref":"Alchemy.Client.html#delete_integration/2","title":"Alchemy.Client.delete_integration/2","type":"function"},{"doc":"Deletes an invite.After deletion the invite can no longer be used, as you might expect.","ref":"Alchemy.Client.html#delete_invite/1","title":"Alchemy.Client.delete_invite/1","type":"function"},{"doc":"Deletes a message.Requires the MANAGE_MESSAGES permission for messages not sent by the user.Examplescontent = &quot;self destructing in 1s!!!&quot; {:ok, message} = Client.send_message(channel_id, content) Process.sleep(1000) Client.delete_message(message)","ref":"Alchemy.Client.html#delete_message/1","title":"Alchemy.Client.delete_message/1","type":"function"},{"doc":"Deletes a list of messages.Requires the MANAGE_MESSAGES permission for messages not posted by this user. Can only delete messages up to 2 weeks old. Cogs.def countdown do {:ok, m1} = Cogs.say &quot;3...&quot; Process.sleep(1000) {:ok, m2} = Cogs.say &quot;2...&quot; Process.sleep(1000) {:ok, m3} = Cogs.say &quot;1...&quot; Process.sleep(1000) Client.delete_messages(message.channel, [m1, m2, m3]) end","ref":"Alchemy.Client.html#delete_messages/2","title":"Alchemy.Client.delete_messages/2","type":"function"},{"doc":"Deletes a reaction added by another user.Requires the MANAGE_MESSAGES permission.","ref":"Alchemy.Client.html#delete_reaction/3","title":"Alchemy.Client.delete_reaction/3","type":"function"},{"doc":"Removes a role from a guild.Requires the :manage_roles permission.","ref":"Alchemy.Client.html#delete_role/2","title":"Alchemy.Client.delete_role/2","type":"function"},{"doc":"Edits a channel in a guild, referenced by id.All the paramaters are optional. Some are mutually exclusive. I.E. you can't use voice only and text only parameters in the same request.Optionsname the name for the channelposition the position in the left hand listingtopic ~ text only ~ the topic of the channelbitrate ~ voice only ~ the bitrate, in bits, from 8000 to 96000, for the voice channel to takeuser_limit ~ voice only ~ the max amount of users allowed in this channel. From 1 to 99, or 0 for no limit.nsfw whether or not the channel is nsfwparent_id the id of the new parent category for a channelExamplesClient.edit_channel(id, name: &quot;the best channel&quot;, position: 1){:ok, new_voice_channel} = Client.edit_channel(id, bitrate: 8000)","ref":"Alchemy.Client.html#edit_channel/2","title":"Alchemy.Client.edit_channel/2","type":"function"},{"doc":"Edits a previously sent embed.Note that this can be accomplished via edit_message/3 as well, but that requires editing the content as well.Cogs.def embed do embed = %Embed{description: &quot;the best embed&quot;} |&gt; color(0xc13261) {:ok, message} = Embed.send(embed) Process.sleep(2000) Client.edit_embed(message, embed |&gt; color(0x5aa4d4)) end","ref":"Alchemy.Client.html#edit_embed/2","title":"Alchemy.Client.edit_embed/2","type":"function"},{"doc":"Modifies a guild's settings.Optionsname The name of the guild.region The id of the voice region.verification_level The level of verification of the guild.default_message_notifications The default message notification settings.afk_channel_id The id of the afk channel.afk_timeout The afk timeout in seconds.icon A url to the new icon. Must be a 128x128 jpeg image.splash A url to the new splash screen. This is only available for partnered guilds.ExamplesClient.edit_guild(guild_id, name: &quot;new name&quot;)","ref":"Alchemy.Client.html#edit_guild/2","title":"Alchemy.Client.edit_guild/2","type":"function"},{"doc":"Edits an integration of a guild.Requires the :manage_guild permission.Optionsexpire_behaviour The behaviour when an integration subscription lapses.expire_grace_period Period (seconds) where the integration ignores lapsed subscriptions.enable_emoticons Whether or not emoticons should be synced for this integration.","ref":"Alchemy.Client.html#edit_integration/3","title":"Alchemy.Client.edit_integration/3","type":"function"},{"doc":"Modifies a member in a guild.Each option requires different permissions.Optionsnick The nickname of the user. Requires :manage_nicknamesroles A list of roles (ids) the user should have after the change. Requires :manage_rolesmute Whether or not the user should be muted. Requires :mute_membersdeaf Whether or not the user should be deafened. Requires :deafen_memberschannel_id Voice channel to move the user too (if they are connected). Requires :move_members, and permission to connect to that channel.ExamplesClient.edit_member(guild_id, user_id, nick: &quot;cool guy&quot;)","ref":"Alchemy.Client.html#edit_member/3","title":"Alchemy.Client.edit_member/3","type":"function"},{"doc":"Edits a message's contents.Examples{:ok, message} = Client.send_message(channel, &quot;ping!&quot;) Process.sleep(1000) Client.edit_message(message, &quot;not ping anymore!&quot;)","ref":"Alchemy.Client.html#edit_message/3","title":"Alchemy.Client.edit_message/3","type":"function"},{"doc":"Edits the client's user_name and/or avatar.Optionsuser_name A string specifiying the new user_name for the clientavatar A link to an image for the client's avatarExamples# Will edit &quot;behind the scenes&quot; Client.edit_profile(username: &quot;NewGuy&quot;, avatar: &quot;imgur.com/image.jpeg&quot;)iex&gt; {:ok, user} = Client.edit_profile(username: &quot;NewName&quot;) {:ok, Alchemy.User%{....","ref":"Alchemy.Client.html#edit_profile/1","title":"Alchemy.Client.edit_profile/1","type":"function"},{"doc":"Edits a preexisting role in a guild.The same as create_role/2 except that this operates on a role that has already been created. See that function for discussion.","ref":"Alchemy.Client.html#edit_role/3","title":"Alchemy.Client.edit_role/3","type":"function"},{"doc":"Gets a list of private channels open with this user.ExamplesClient.get_DMs()","ref":"Alchemy.Client.html#get_DMs/0","title":"Alchemy.Client.get_DMs/0","type":"function"},{"doc":"Gets a list of users banned from this guild.Requires the :ban_members permission.Examples{:ok, bans} = Client.get_bans(guild_id)","ref":"Alchemy.Client.html#get_bans/1","title":"Alchemy.Client.get_bans/1","type":"function"},{"doc":"Gets a channel by its ID. Works on both private channels, and guild channels.Examples{:ok, channel} = Client.get_channel(&quot;id&quot;)","ref":"Alchemy.Client.html#get_channel/1","title":"Alchemy.Client.get_channel/1","type":"function"},{"doc":"Gets a list of invites for a channel.Only usable for guild channels.ExamplesCogs.def count_invites do {:ok, invites} = Client.get_channel_invites(message.channel_id) Cogs.say(&quot;there are \#{length(invites)} invites active in this channel&quot;) end","ref":"Alchemy.Client.html#get_channel_invites/1","title":"Alchemy.Client.get_channel_invites/1","type":"function"},{"doc":"Returns a list of channel objects for a guild.As with most guild methods, the cache should be preferred over the api if possible.ExamplesClient.get_channels(guild_id)","ref":"Alchemy.Client.html#get_channels/1","title":"Alchemy.Client.get_channels/1","type":"function"},{"doc":"Gets a list of guilds the client is currently a part of.Examples{:ok, guilds} = Client.current_guilds","ref":"Alchemy.Client.html#get_current_guilds/0","title":"Alchemy.Client.get_current_guilds/0","type":"function"},{"doc":"Gets info about a certain guild.The info returned here doesn't contain as much info as contained in the cache. For guilds the user is a part of, the cache should be preferred over this method.Client.get_guild(id)","ref":"Alchemy.Client.html#get_guild/1","title":"Alchemy.Client.get_guild/1","type":"function"},{"doc":"Gets a list of integration objects for a guild.Requires the :manage_guild permission.","ref":"Alchemy.Client.html#get_integrations/1","title":"Alchemy.Client.get_integrations/1","type":"function"},{"doc":"Gets the information for a single invite.Not to be confused with get_invites/1, which lists out the invites in a guild. This merely gets the information relating to a single invite, accessed by its code.","ref":"Alchemy.Client.html#get_invite/1","title":"Alchemy.Client.get_invite/1","type":"function"},{"doc":"Returns a list of invites for a guild.Requires the :manage_guild permission.","ref":"Alchemy.Client.html#get_invites/1","title":"Alchemy.Client.get_invites/1","type":"function"},{"doc":"Gets info for a member of a guild.For guilds the bot is in, use the corresponding cache method instead.ExamplesClient.get_member(guild_id, user_id)","ref":"Alchemy.Client.html#get_member/2","title":"Alchemy.Client.get_member/2","type":"function"},{"doc":"Gets a list of members from a guild.Optionslimit The number of members to fetch (max 1000).after Setting this to a user id will only fetch members that joined after that person.ExamplesClient.get_member_list(guild_id, limit: 10)","ref":"Alchemy.Client.html#get_member_list/2","title":"Alchemy.Client.get_member_list/2","type":"function"},{"doc":"Gets a message by channel, and message_idUse get_messages for a bulk request instead.Examples{:ok, message} = Client.get_message(channel, id)","ref":"Alchemy.Client.html#get_message/2","title":"Alchemy.Client.get_message/2","type":"function"},{"doc":"Gets up to 100 messages from a channel.around, before, after are all mutually exclusive.Optionsaround will search for messages around the time of a particular messagebefore will get messages before a certain messageafter will get messages after a certain messagelimit the number of messages to get. Defaults to 100Examples{:ok, messages} = Client.get_messages(around: id, limit: 40)","ref":"Alchemy.Client.html#get_messages/2","title":"Alchemy.Client.get_messages/2","type":"function"},{"doc":"Gets a list of pinned messages in a channel.ExamplesCogs.def pins do {:ok, pinned} = Client.get_pins(message.channel_id) Cogs.say(&quot;there are \#{length(pinned)} pins in this channel.&quot;) end","ref":"Alchemy.Client.html#get_pins/1","title":"Alchemy.Client.get_pins/1","type":"function"},{"doc":"Returns a count of members who would be kicked in a prune operation.Days specifies the amount of days of inactivity to check for.See prune_guild/2 for a discussion of this operation.","ref":"Alchemy.Client.html#get_prune_count/2","title":"Alchemy.Client.get_prune_count/2","type":"function"},{"doc":"Gets a list of users who reacted to message with a particular emoji.ExamplesCogs.def react do {:ok, message} = Cogs.say(&quot;react to this!&quot;) Process.sleep(10000) {:ok, users} = Client.get_reactions(message, &quot;❤&quot;) Cogs.say(&quot;\#{length(users)} users reacted with a ❤!&quot;) end","ref":"Alchemy.Client.html#get_reactions/2","title":"Alchemy.Client.get_reactions/2","type":"function"},{"doc":"Returns a list of voice regions in a guild.","ref":"Alchemy.Client.html#get_regions/1","title":"Alchemy.Client.get_regions/1","type":"function"},{"doc":"Gets a list of roles available in a guild.Requires the :manage_roles permission.ExamplesClient.get_roles(guild_id)","ref":"Alchemy.Client.html#get_roles/1","title":"Alchemy.Client.get_roles/1","type":"function"},{"doc":"Gets a user by their client_id.&quot;@me&quot; can be passed to get the info relevant to the Client.Examplesiex&gt; {:ok, user} = Client.get_user(&quot;client_id&quot;) {:ok, Alchemy.User%{....","ref":"Alchemy.Client.html#get_user/1","title":"Alchemy.Client.get_user/1","type":"function"},{"doc":"Callback implementation for Supervisor.init/1.","ref":"Alchemy.Client.html#init/1","title":"Alchemy.Client.init/1","type":"function"},{"doc":"Kicks a member from a guild.Not to be confused with ban_member/3.ExamplesClient.kick_member(guild_id, user_id)","ref":"Alchemy.Client.html#kick_member/2","title":"Alchemy.Client.kick_member/2","type":"function"},{"doc":"Makes the client leave a guild.ExamplesClient.leave_guild(guild_id)","ref":"Alchemy.Client.html#leave_guild/1","title":"Alchemy.Client.leave_guild/1","type":"function"},{"doc":"Returns a list of all possible voice regions.","ref":"Alchemy.Client.html#list_voice_regions/0","title":"Alchemy.Client.list_voice_regions/0","type":"function"},{"doc":"Swaps the position of channels in a guild.Examples# alphabetizes a guild channel list with {:ok, channels} &lt;- Client.get_channels(guild_id) do channels |&gt; Enum.sort_by(&amp; &amp;1.name) |&gt; Stream.map(&amp; &amp;1.id) |&gt; Enum.with_index |&gt; (&amp;Client.move_channels(guild_id, &amp;1)).() end","ref":"Alchemy.Client.html#move_channels/2","title":"Alchemy.Client.move_channels/2","type":"function"},{"doc":"Modifies the position of roles in a guild.Takes a list of {id, position} where position is an integer starting at 0, and id is the id of the role.Returns a list of all the roles in the guild.Requires the :manage_roles permission.","ref":"Alchemy.Client.html#move_roles/2","title":"Alchemy.Client.move_roles/2","type":"function"},{"doc":"Pins a message to its channel.ExamplesCogs.def pin_this do Client.pin(message) end","ref":"Alchemy.Client.html#pin/1","title":"Alchemy.Client.pin/1","type":"function"},{"doc":"Removes inactive members of a guild.Days allows you to specify the amount of days of inactivity necessary to be kicked from the guild.Requires the :manage_roles permissionExamplesClient.prune_guild(guild_id, )","ref":"Alchemy.Client.html#prune_guild/2","title":"Alchemy.Client.prune_guild/2","type":"function"},{"doc":"Removes a reaction on a message, posted by this user.This doesn't require the MANAGE_MESSAGES permission, unlike delete_reaction.ExampleCogs.def indecisive do Client.add_reaction(message, &quot;❤&quot;) Process.sleep(3000) Client.remove_reaction(message, &quot;❤&quot;) end","ref":"Alchemy.Client.html#remove_reaction/2","title":"Alchemy.Client.remove_reaction/2","type":"function"},{"doc":"Removes all reactions from a message.Requires the MANAGE_MESSAGES permission.ExamplesCogs.def psyche do {:ok, message} = Cogs.say(&quot;react to this&quot;) Process.sleep(10000) Client.delete_reactions(message) end","ref":"Alchemy.Client.html#remove_reactions/1","title":"Alchemy.Client.remove_reactions/1","type":"function"},{"doc":"Removes a role of a guild member.Requires the :manage_roles permission.ExamplesClient.remove_role(guild_id, user_id, role_id)","ref":"Alchemy.Client.html#remove_role/3","title":"Alchemy.Client.remove_role/3","type":"function"},{"doc":"Sends a message to a particular channelOptionstts used to set whether or not a message should be text to speechembed used to send an Embed object along with the messagefile used to send a file along with the messageExamples{:ok, message} = Client.send_message(chan_id, &quot;pong!&quot;)Sending files along with messages is simple as well.Client.send_message(chan_id, &quot;here you go!&quot;, file: &quot;foo.txt&quot;)","ref":"Alchemy.Client.html#send_message/3","title":"Alchemy.Client.send_message/3","type":"function"},{"doc":"Starts up a new Client with the given token.An optional selfbot: id can be passed, indiciating that you're using a user token instead of a normal bot token. SelfBots will only respond to themselves, and certain functionalities of the API may not work as well as for normal bots.","ref":"Alchemy.Client.html#start/2","title":"Alchemy.Client.start/2","type":"function"},{"doc":"Syncs a guild integration.Requires the :manage_guild permission.","ref":"Alchemy.Client.html#sync_integration/2","title":"Alchemy.Client.sync_integration/2","type":"function"},{"doc":"Triggers the typing indicator.This shouldn't be used by bots usually.ExamplesCogs.def hard_math do Client.trigger_typing(message.channel_id) Process.sleep(3000) Cogs.say(&quot;done!&quot;) end","ref":"Alchemy.Client.html#trigger_typing/1","title":"Alchemy.Client.trigger_typing/1","type":"function"},{"doc":"Unbans a user from the server.ExamplesClient.unban_member(guild_id, user_id)","ref":"Alchemy.Client.html#unban_member/2","title":"Alchemy.Client.unban_member/2","type":"function"},{"doc":"Removes a pinned message from a channel.ExamplesCogs.def unpin do {:ok, [first|_]} = Client.get_pins(message.channel_id) Client.unpin(first) end","ref":"Alchemy.Client.html#unpin/1","title":"Alchemy.Client.unpin/1","type":"function"},{"doc":"Updates the status of the client.The status displays either &quot;playing Game&quot;, or a &quot;streaming Game&quot; message under the client, as well setting an inactivity based on idleness.playing: game specifies that you're playing, but not streaming a game. streaming: {game, twitch} acts in a similar way, except that it will also have a link to that twitch stream. You should only pass in the handle, and not the full stream link, i.e. &quot;foobar&quot; instead of &quot;twitch.tv/foobar&quot;. idle_since can be specified, using unix time, in milliseconds, to indicate for how long the client has been idle.Note on ratelimitingThis functionality is heavily ratelimited, at a rate of 1 req / 12s. Because of this, this function will automatically error after 24s of waiting. Because of how long this may take, you might want to run this in a new task.ExamplesClient.update_status(&quot;Alchemy&quot;)","ref":"Alchemy.Client.html#update_status/2","title":"Alchemy.Client.update_status/2","type":"function"},{"doc":"","ref":"Alchemy.Client.html#t:channel_id/0","title":"Alchemy.Client.channel_id/0","type":"type"},{"doc":"","ref":"Alchemy.Client.html#t:message_id/0","title":"Alchemy.Client.message_id/0","type":"type"},{"doc":"","ref":"Alchemy.Client.html#t:snowflake/0","title":"Alchemy.Client.snowflake/0","type":"type"},{"doc":"","ref":"Alchemy.Client.html#t:token/0","title":"Alchemy.Client.token/0","type":"type"},{"doc":"","ref":"Alchemy.Client.html#t:unicode/0","title":"Alchemy.Client.unicode/0","type":"type"},{"doc":"","ref":"Alchemy.Client.html#t:url/0","title":"Alchemy.Client.url/0","type":"type"},{"doc":"This module provides quite a bit of sugar for registering commands.To use the macros in this module, it must be used. This also defines a __using__ macro for that module, which will then allow these commands to be loaded in the main application via useExample Moduledefmodule Example do use Alchemy.Cogs Cogs.def ping do Cogs.say &quot;pong&quot; end Cogs.def echo do Cogs.say &quot;please give me a word to echo&quot; end Cogs.def echo(word) do Cogs.say word end endThis defines a basic Cog, that can now be loaded into our application via use. The command created from this module are &quot;!ping&quot;, and &quot;!echo&quot;, (&quot;!&quot; is merely the default prefix, it could be anything from &quot;?&quot;, to &quot;SHARKNADO&quot;). The ping command is straight forward, but as you can see, the echo command takes in an argument. When you define a command, the handler will try and get arguments up to the max arity of that command; in this case, echo has a max arity of one, so the parser will pass up to one argument to the function. In the case that the parser can't get enough arguments, it will pass a lower amount. We explicitly handle this case here, in this case sending a useful error message back.Shared names across multiple modulesIf I define a command ping in module A, and a ping in module B, which ping should become the command? In general, you should avoid doing this, but the module used last will override previously loaded commands with a matching name.ParsingThe way the parser works is simple: a message is first decomposed into parts:prefix &lt;&gt; command &lt;&gt; &quot; &quot; &lt;&gt; restIf the prefix doesn't match, the message is ignored. If it does match, a new Task is started to handle this event. This task will try and find the function corresponding to the command called, and will return preemptively if no such function is found. After that, rest is passed to the parser, which will try and extract arguments to pass to the function. The default parsing method is simply splitting by whitespace. Thankfully, you can define a custom parser for a command via Cogs.set_parser/2. This parser will act upon rest, and parse out the relevant arguments.The message argumentWhen you define a function with Cogs.def the function gets expanded to take an extra message parameter, which is the message triggering the command. This contains a lot of useful information, and is what enables a lot of the other macros to work. Because of this, be wary of naming something else message.Loading and UnloadingLoading a cog merely requires having started the client:use ExampleIf you need to remove this cog from the handler:Cogs.unload(Example)Or you just want to disable a single function:Cogs.disable(:ping)","ref":"Alchemy.Cogs.html","title":"Alchemy.Cogs","type":"module"},{"doc":"Returns a map from command name (string) to the command information.Each command is either {module, arity, function_name}, or {module, arity, function_name, parser}.This can be useful for providing some kind of help command, or telling a user if a command is defined, e.g. :Cogs.def iscommand(maybe) do case Cogs.all_commands()[maybe] do nil -&gt; Cogs.say &quot;\#{maybe} is not a command&quot; _ -&gt; Cogs.say &quot;\#{maybe} is a command&quot; end end","ref":"Alchemy.Cogs.html#all_commands/0","title":"Alchemy.Cogs.all_commands/0","type":"function"},{"doc":"Registers a new command, under the name of the function.This macro modifies the function definition, to accept an extra message parameter, allowing the message that triggered the command to be passed, as a t:Alchemy.Message/0ExamplesCogs.def ping do Cogs.say &quot;pong&quot; endIn this case, &quot;!ping&quot; will trigger the command, unless another prefix has been set with set_prefix/1Cogs.def mimic, do: Cogs.say &quot;Please send a word for me to echo&quot; Cogs.def mimic(word), do: Cogs.say wordMessages will be parsed, and arguments will be extracted, however, to deal with potentially missing arguments, pattern matching should be used. So, in this case, when a 2nd argument isn't given, an error message is sent back.","ref":"Alchemy.Cogs.html#def/2","title":"Alchemy.Cogs.def/2","type":"macro"},{"doc":"Disables a command.If you want to remove a whole module from the cogs, use Cogs.unload/1.This will stop a command from being triggered. The only way to reenable the command is to reload the module with use.Examplesdefmodule Example do use Alchemy.Cogs Cogs.def ping, do: Cogs.say &quot;pong&quot; Cogs.def foo, do: Cogs.say &quot;bar&quot; endClient.start(@token) use Example Cogs.disable(:foo)Only ping will be triggerable now.use ExampleAt runtime this will add foo back in, given it's still in the module.","ref":"Alchemy.Cogs.html#disable/1","title":"Alchemy.Cogs.disable/1","type":"function"},{"doc":"Makes all commands in this module sub commands of a group.Examplesdefmodule C do use Alchemy.Cogs Cogs.group(&quot;cool&quot;) Cogs.def foo, do: Cogs.say &quot;foo&quot; endTo use this foo command, one has to type !cool foo, from there on arguments will be passed like normal.The relevant parsing will be done in the command task, as if there were a command !cool that redirected to subfunctions. Because of this, Cogs.disable/1 will not be able to disable the subcommands, however, Cogs.unload/1 still works as expected. Reloading a grouped module will also disable removed commands, unlike with ungrouped modules.","ref":"Alchemy.Cogs.html#group/1","title":"Alchemy.Cogs.group/1","type":"macro"},{"doc":"Gets the guild struct from which a command was triggered.If only the id is needed, see :guild_id/0ExamplesCogs.def guild do {:ok, %Alchemy.Guild{name: name}} = Cogs.guild() Cogs.say(name) end","ref":"Alchemy.Cogs.html#guild/0","title":"Alchemy.Cogs.guild/0","type":"macro"},{"doc":"Gets the id of the guild from which a command was triggered.Returns {:ok, id}, or {:error, why}. Will never return ok outside of a guild, naturally. This is to be used when the guild_id is necessary for an operation, but the full guild struct isn't needed.","ref":"Alchemy.Cogs.html#guild_id/0","title":"Alchemy.Cogs.guild_id/0","type":"macro"},{"doc":"Returns the base permissions for a member in a guild.Functions similarly to permissions.","ref":"Alchemy.Cogs.html#guild_permissions/0","title":"Alchemy.Cogs.guild_permissions/0","type":"macro"},{"doc":"Gets the member that triggered a command.Returns either {:ok, member}, or {:error, why}. Will not return ok if the command wasn't run in a guild. As opposed to message.author, this comes with a bit more info about who triggered the command. This is useful for when you want to use certain information in a command, such as permissions, for example.","ref":"Alchemy.Cogs.html#member/0","title":"Alchemy.Cogs.member/0","type":"macro"},{"doc":"Returns the permission bitset of the current member in the channel the command was called from.If you just want the base permissions of the member in the guild, see guild_permissions. Returns {:ok, perms}, or {:error, why}. Fails if not called from a guild, or the guild or the member couldn't be fetched from the cache.ExampleCogs.def perms do with {:ok, permissions} &lt;- Cogs.permissions() do Cogs.say &quot;Here&#39;s a list of your permissions `\#{Permissions.to_list(permissions)}`&quot; end end","ref":"Alchemy.Cogs.html#permissions/0","title":"Alchemy.Cogs.permissions/0","type":"macro"},{"doc":"Sends a message to the same channel as the message triggering a command.This can only be used in a command defined with Cogs.defThis is just a thin macro around Alchemy.Client.send_message/2ExamplesCogs.def ping, do: Cogs.say(&quot;pong!&quot;)","ref":"Alchemy.Cogs.html#say/2","title":"Alchemy.Cogs.say/2","type":"macro"},{"doc":"Allows you to register a custom message parser for a command.The parser will be applied to part of the message not used for command matching.prefix &lt;&gt; command &lt;&gt; &quot; &quot; &lt;&gt; restExamplesCogs.set_parser(:echo, &amp;List.wrap/1) Cogs.def echo(rest) do Cogs.say(rest) end","ref":"Alchemy.Cogs.html#set_parser/2","title":"Alchemy.Cogs.set_parser/2","type":"macro"},{"doc":"Sets the client's command prefix to a specific string.This will only work after the client has been startedExampleClient.start(@token) Cogs.set_prefix(&quot;!!&quot;)","ref":"Alchemy.Cogs.html#set_prefix/1","title":"Alchemy.Cogs.set_prefix/1","type":"function"},{"doc":"Unloads a module from the handler.If you just want to disable a single command, use Cogs.disable/1ExamplesClient.start(@token) use Commands2Turns out we want to stop using Commands2 commands in our bot, so we can simply unload the module:Cogs.unload(Commands2)Now none of the commands defined in that module will be accessible. If we want to reverse that, we can merely do:use Commands2and reload them back in.","ref":"Alchemy.Cogs.html#unload/1","title":"Alchemy.Cogs.unload/1","type":"function"},{"doc":"Halts the current command until an event is received.The event type is an item corresponding to the events in Alchemy.Events, i.e. on_message_edit -&gt; Cogs.wait_for(:message_edit, ...). The fun is the function that gets called with the relevant event arguments; see Alchemy.Events for more info on what events have what arguments.The :message event is a bit special, as it will specifically wait for a message not triggered by a bot, in that specific channel, unlike other events, which trigger generically across the entire bot.The process will kill itself if it doesn't receive any such event for 20s.ExamplesCogs.def color do Cogs.say &quot;What&#39;s your favorite color?&quot; Cogs.wait_for :message, fn msg -&gt; Cogs.say &quot;\#{msg.content} is my favorite color too!&quot; end endCogs.def typing do Cogs.say &quot;I&#39;m waiting for someone to type..&quot; Cogs.wait_for :typing, fn _,_,_ -&gt; Cogs.say &quot;Someone somewhere started typing...&quot; end","ref":"Alchemy.Cogs.html#wait_for/2","title":"Alchemy.Cogs.wait_for/2","type":"macro"},{"doc":"Waits for a specific event satisfying a condition.Same as wait_for/2, except this takes an extra condition that needs to be met for the waiting to handle to trigger.ExamplesCogs.def foo do Cogs.say &quot;Send me foo&quot; Cogs.wait_for(:message, &amp; &amp;1.content == &quot;foo&quot;, fn _msg -&gt; Cogs.say &quot;Nice foo man!&quot; end)Note that, if no event of the given type is received after 20s, the process will kill itself, it's possible that this will never get met, but no event satisfying the condition will ever arrive, essentially rendering the process a waste. To circumvent this, it might be smart to send a preemptive kill message:self = self() Task.start(fn -&gt; Process.sleep(20_000) Process.exit(self, :kill) ) Cogs.wait_for(:message, fn x -&gt; false end, fn _msg -&gt; Cogs.say &quot;If you hear this, logic itself is falling apart!!!&quot; end)","ref":"Alchemy.Cogs.html#wait_for/3","title":"Alchemy.Cogs.wait_for/3","type":"macro"},{"doc":"","ref":"Alchemy.Cogs.html#t:parser/0","title":"Alchemy.Cogs.parser/0","type":"type"},{"doc":"A module containing structs and functions relative to Embeds.Embeds allow you to format messages in a structured, and quite pretty way; much more than can be done with simple text. For a basic idea of how embeds work, check this link.Example UsageCogs.def embed do %Embed{} |&gt; title(&quot;The BEST embed&quot;) |&gt; description(&quot;the best description&quot;) |&gt; image(&quot;http://i.imgur.com/4AiXzf8.jpg&quot;) |&gt; Embed.send endNote that this is equivalent to:Cogs.def embed do %Embed{title: &quot;The BEST embed&quot;, description: &quot;the best description&quot;, image: &quot;http://i.imgur.com/4AiXzf8.jpg&quot;} |&gt; Embed.send endFile AttachmentsThe fields that take urls can also take a special &quot;attachment&quot; url referencing files uploaded alongside the embed.Cogs.def foo do %Embed{} |&gt; image(&quot;attachment://foo.png&quot;) |&gt; Embed.send(&quot;&quot;, file: &quot;foo.png&quot;) end","ref":"Alchemy.Embed.html","title":"Alchemy.Embed","type":"module"},{"doc":"Adds author information to an embed.Note that the proxy_icon_url, height, and width fields have no effect, when using a pre-made Author struct.OptionsnameThe name of the author.urlThe url of the author.icon_urlThe url of the icon to display.ExamplesCogs.def embed do %Embed{} |&gt; author(name: &quot;John&quot;, url: &quot;https://discord.com/developers&quot; icon_url: &quot;http://i.imgur.com/3nuwWCB.jpg&quot;) |&gt; Embed.send end","ref":"Alchemy.Embed.html#author/2","title":"Alchemy.Embed.author/2","type":"function"},{"doc":"Sets the color of an embedColor should be 3 byte integer, with each byte representing a single color component; i.e. 0xRrGgBbExamplesCogs.def embed do {:ok, message} = %Embed{description: &quot;the best embed&quot;} |&gt; color(0xc13261) |&gt; Embed.send Process.sleep(2000) Client.edit_embed(message, embed |&gt; color(0x5aa4d4)) end","ref":"Alchemy.Embed.html#color/2","title":"Alchemy.Embed.color/2","type":"function"},{"doc":"Adds a description to an embed.Cogs.def embed(description) do %Embed{} |&gt; title(&quot;generic title&quot;) |&gt; description(description) |&gt; Embed.send end","ref":"Alchemy.Embed.html#description/2","title":"Alchemy.Embed.description/2","type":"function"},{"doc":"Adds a field to an embed.Fields are appended when using this method, so the order you pipe them in, is the order they'll end up when sent. The name and value must be non empty strings. You can have a maximum of 25 fields.ParametersnameThe title of the embed.valueThe text of the fieldOptionsinlineWhen setting this to true, up to 3 fields can appear side by side, given they are all inlined.Examples%Embed{} |&gt; field(&quot;Field1&quot;, &quot;the best field!&quot;) |&gt; field(&quot;Inline1&quot;, &quot;look a field -&gt;&quot;) |&gt; field(&quot;Inline2&quot;, &quot;&lt;- look a field&quot;)","ref":"Alchemy.Embed.html#field/4","title":"Alchemy.Embed.field/4","type":"function"},{"doc":"Adds a footer to an embed.Note that the proxy_icon_url field has no effect, when using a pre-made Footer struct.OptionstextThe content of the footer.icon_urlThe icon the footer should haveExamplesCogs.def you do %Embed{} |&gt; footer(text: &quot;&lt;- this is you&quot;, icon_url: message.author |&gt; User.avatar_url) |&gt; Embed.send end","ref":"Alchemy.Embed.html#footer/2","title":"Alchemy.Embed.footer/2","type":"function"},{"doc":"Sets the main image of the embed.Examples%Embed{} |&gt; image(&quot;http://i.imgur.com/4AiXzf8.jpg&quot;)","ref":"Alchemy.Embed.html#image/2","title":"Alchemy.Embed.image/2","type":"function"},{"doc":"Sends an embed to the same channel as the message triggering a command.This macro can't be used outside of Alchemy.Cogs commands.See Alchemy.Client.send_message/3 for a list of options that can be passed to this macro.ExamplesCogs.def blue do %Embed{} |&gt; color(0x1d3ad1) |&gt; description(&quot;Hello!&quot;) |&gt; Embed.send(&quot;Here&#39;s an embed, and a file&quot;, file: &quot;foo.txt&quot;) end","ref":"Alchemy.Embed.html#send/3","title":"Alchemy.Embed.send/3","type":"macro"},{"doc":"Adds a thumbnail to an embed.Examples%Embed{} |&gt; thumbnail(&quot;http://i.imgur.com/4AiXzf8.jpg&quot;)","ref":"Alchemy.Embed.html#thumbnail/2","title":"Alchemy.Embed.thumbnail/2","type":"function"},{"doc":"Adds a timestamp to an embed.Note that the Datetime object will get converted to an iso8601 formatted string.Examples%Embed{} |&gt; timestamp(DateTime.utc_now())","ref":"Alchemy.Embed.html#timestamp/2","title":"Alchemy.Embed.timestamp/2","type":"function"},{"doc":"Adds a title to an embed.ExamplesCogs.def title(string) do %Embed{} |&gt; title(string) |&gt; Embed.send end","ref":"Alchemy.Embed.html#title/2","title":"Alchemy.Embed.title/2","type":"function"},{"doc":"Sets the url for an embed.ExamplesCogs.def embed(url) do %Embed{} |&gt; url(url) |&gt; Embed.send end","ref":"Alchemy.Embed.html#url/2","title":"Alchemy.Embed.url/2","type":"function"},{"doc":"Represents a file attached to an embed.idThe attachment idfilenameThe name of the file attachedsizeThe size of the file attachedurlThe source url of a fileproxy_urlA proxied url of a fileheightThe height of the file, if it's an imagewidthThe width of a file, if it's an image","ref":"Alchemy.Embed.html#t:attachment/0","title":"Alchemy.Embed.attachment/0","type":"type"},{"doc":"Represents the author of an embed.nameThe name of the authorurlThe author's urlicon_urlA link to the author's icon imageproxy_icon_urlA proxied url for the author's icon image","ref":"Alchemy.Embed.html#t:author/0","title":"Alchemy.Embed.author/0","type":"type"},{"doc":"Represents a field in an embed.nameThe title of the fieldvalueThe text of the fieldinlineWhether or not the field should be aligned with other inline fields.","ref":"Alchemy.Embed.html#t:field/0","title":"Alchemy.Embed.field/0","type":"type"},{"doc":"Represents an Embed footer.textThe text of the footericon_urlThe url of the image in the footerproxy_icon_urlThe proxied url of the footer's icon. Setting this when sending an embed serves no purpose.","ref":"Alchemy.Embed.html#t:footer/0","title":"Alchemy.Embed.footer/0","type":"type"},{"doc":"Represents the image of an embed.urlA link to this imageThe following parameters shouldn't be set when sending embeds:proxy_urlA proxied url of the imageheightThe height of the image.widthThe width of the image.","ref":"Alchemy.Embed.html#t:image/0","title":"Alchemy.Embed.image/0","type":"type"},{"doc":"Represents the provider of an embed.This is usually comes from a linked resource (youtube video, etc.)nameThe name of the providerurlThe source of the provider","ref":"Alchemy.Embed.html#t:provider/0","title":"Alchemy.Embed.provider/0","type":"type"},{"doc":"","ref":"Alchemy.Embed.html#t:t/0","title":"Alchemy.Embed.t/0","type":"type"},{"doc":"Represents the thumnail of an embed.urlA link to the thumbnail image.proxy_urlA proxied link to the thumbnail imageheightThe height of the thumbnailwidthThe width of the thumbnail","ref":"Alchemy.Embed.html#t:thumbnail/0","title":"Alchemy.Embed.thumbnail/0","type":"type"},{"doc":"","ref":"Alchemy.Embed.html#t:url/0","title":"Alchemy.Embed.url/0","type":"type"},{"doc":"Represents a video attached to an embed.Users can't set this themselves.urlThe source of the videoheightThe height of the videowidthThe width of the video","ref":"Alchemy.Embed.html#t:video/0","title":"Alchemy.Embed.video/0","type":"type"},{"doc":"This module provides raw Event hooks into the various events supplied by the gateway.To use the macros in this module, it must be used. This also defines a __using__ macro for that module, which will then allow those hooks to be loaded in the main application via use.Example Usagedefmodule Example do use Alchemy.Events Events.on_message(:inspect) def inspect(message) do IO.inspect message.content end end defmodule Application do use Application alias Alchemy.Client def start(_type, _args) do run = Client.start(@token) use Example run end end","ref":"Alchemy.Events.html","title":"Alchemy.Events","type":"module"},{"doc":"Unhooks a function from the event handler.If you want to unhook all the functions in a module, see Events.unload/1. Because you can have multiple hooks with the same name, this function takes both the module and the function name.Examplesdefmodule Annoying do use Alchemy.Events Events.on_message(:inspect) def inspect(message), do: IO.inspect message.content endThis function is annoying us, so we can easily disable it:Events.disable(Annoying, :inspect)If we want to turn it back on, we can of course douse Annoying","ref":"Alchemy.Events.html#disable/2","title":"Alchemy.Events.disable/2","type":"function"},{"doc":"Registers a handle triggering whenever a user starts a DM with the client.args : Alchemy.Channel.dm_channelAs opposed to on_channel_create, this event gets triggered when a user starts a direct message with this client.ExamplesEvents.on_DMChannel_create(:foo) def foo(%DMChannel{recipients: [user|_]}) do IO.inspect user.name &lt;&gt; &quot; just DMed me!&quot; end","ref":"Alchemy.Events.html#on_DMChannel_create/1","title":"Alchemy.Events.on_DMChannel_create/1","type":"macro"},{"doc":"Registers a handle triggering whenever a user closes a DM with the client.args : Alchemy.Channel.dm_channel","ref":"Alchemy.Events.html#on_DMChannel_delete/1","title":"Alchemy.Events.on_DMChannel_delete/1","type":"macro"},{"doc":"Registers a handle triggering whenever messages get bulk deleted from a channel.args : [snowflake], snowflakeReceives a list of message ids that were deleted, and the channel they were deleted from.","ref":"Alchemy.Events.html#on_bulk_delete/1","title":"Alchemy.Events.on_bulk_delete/1","type":"macro"},{"doc":"Registers a handle triggering whenever a channel gets created.args : Alchemy.Channel.tAs opposed to on_DMChannel_create, this gets triggered when a channel gets created in a guild, and not when a user starts a DM with this client.ExamplesEvents.on_channel_create(:foo) def foo(channel), do: IO.inspect channel.name","ref":"Alchemy.Events.html#on_channel_create/1","title":"Alchemy.Events.on_channel_create/1","type":"macro"},{"doc":"Registers a handle triggering whenever a guild channel gets removed.args : Alchemy.Channel.t","ref":"Alchemy.Events.html#on_channel_delete/1","title":"Alchemy.Events.on_channel_delete/1","type":"macro"},{"doc":"Registers a handle triggering whenever a guild channel gets updated.args : Alchemy.Channel.tExamplesEvents.on_channel_update(:foo) def foo(channel) do IO.inspect &quot;\#{channel.name} was updated&quot; end","ref":"Alchemy.Events.html#on_channel_update/1","title":"Alchemy.Events.on_channel_update/1","type":"macro"},{"doc":"Registers a handle triggering whenever a guild's emojis get updated.args : [Guild.emoji], snowflakeReceives a list of the current emojis in the guild, after this event, and the id of the guild itself.","ref":"Alchemy.Events.html#on_emoji_update/1","title":"Alchemy.Events.on_emoji_update/1","type":"macro"},{"doc":"Registers a handle triggering whenever this client joins a guild.args : Alchemy.Guild.tA good amount of these events fire when the client initially connects to the gateway, and don't actually represent the client joining a new guild.","ref":"Alchemy.Events.html#on_guild_join/1","title":"Alchemy.Events.on_guild_join/1","type":"macro"},{"doc":"Registers a handle triggering whenever the client leaves a guild.args : snowflakeThe id of the guild the client left gets sent to the hook.","ref":"Alchemy.Events.html#on_guild_leave/1","title":"Alchemy.Events.on_guild_leave/1","type":"macro"},{"doc":"Registers a handle triggering whenever a guild comes back online.args : Alchemy.Guild.tSometimes due to outages, or other problems, guild may go offline. This can be checked via guild.unavailable. This event gets triggered whenever a guild comes back online after an outage.","ref":"Alchemy.Events.html#on_guild_online/1","title":"Alchemy.Events.on_guild_online/1","type":"macro"},{"doc":"Registers a handle triggering whenever a guild gets updated.args : Alchemy.Guild.tA guild gets updated for various reasons, be it a member or role edition, or something else. The guild updated with this new info will be sent to the hook.","ref":"Alchemy.Events.html#on_guild_update/1","title":"Alchemy.Events.on_guild_update/1","type":"macro"},{"doc":"Registers a handle triggering whenever a guild's integrations get updated.args : snowflakeLike other guild events, the info doesn't actually come through this event, but through on_guild_update. This hook is merely useful for reacting to the event having happened.","ref":"Alchemy.Events.html#on_integrations_update/1","title":"Alchemy.Events.on_integrations_update/1","type":"macro"},{"doc":"Registers a handle triggering whenever a shard receives a member chunk.This event gets sent after a shard has requested offline guild member info for a guild.args : snowflake, [Alchemy.Guild.GuildMember] Receives the id of the guild the members are from, and a list of members loaded.","ref":"Alchemy.Events.html#on_member_chunk/1","title":"Alchemy.Events.on_member_chunk/1","type":"macro"},{"doc":"Registers a handle triggering whenever a member joins a guild.args : snowflakeThe information of the member doesn't actually come through this event, but through on_guild_update.","ref":"Alchemy.Events.html#on_member_join/1","title":"Alchemy.Events.on_member_join/1","type":"macro"},{"doc":"Registers a handle triggering when a member leaves a guild.args : Alchemy.User.t, snowflakeReceives the user that left the guild, and the id of the guild they've left.","ref":"Alchemy.Events.html#on_member_leave/1","title":"Alchemy.Events.on_member_leave/1","type":"macro"},{"doc":"Registers a handle triggering when the status of a member changes in a guild.args : Alchemy.Guild.Guild.member, snowflakeReceives the member that was updated, and the guild they belong to.","ref":"Alchemy.Events.html#on_member_update/1","title":"Alchemy.Events.on_member_update/1","type":"macro"},{"doc":"Registers a handle triggering whenever a message gets sent.args : Alchemy.Message.tExamplesuse Alchemy.Events Events.on_message(:ping) def ping(msg), do: IO.inspect msg.content","ref":"Alchemy.Events.html#on_message/1","title":"Alchemy.Events.on_message/1","type":"macro"},{"doc":"Registers a handle triggering whenever a single message gets deleted.args : snowflake, snowflakeReceives the id of the message that was deleted, and the channel it was deleted from.","ref":"Alchemy.Events.html#on_message_delete/1","title":"Alchemy.Events.on_message_delete/1","type":"macro"},{"doc":"Registers a handle triggering whenever a message gets edited.args : snowflake, snowflakeReceives the id of the message that was edited, and the channel it was edited in.","ref":"Alchemy.Events.html#on_message_edit/1","title":"Alchemy.Events.on_message_edit/1","type":"macro"},{"doc":"Registers a handle triggering whenever the presence of a user gets updated in a guild.args : Alchemy.Presence.tThe presence struct here may be very incomplete.","ref":"Alchemy.Events.html#on_presence_update/1","title":"Alchemy.Events.on_presence_update/1","type":"macro"},{"doc":"Registers a handle triggering whenever a user reacts to a message.args : snowflake, snowflake, snowflake %{&quot;animated&quot; =&gt; boolean, &quot;id&quot; =&gt; integer, &quot;name&quot; =&gt; String.t}Receives the id of the user that reacted, the channel_id where it happened, the message_id and the emoji","ref":"Alchemy.Events.html#on_reaction_add/1","title":"Alchemy.Events.on_reaction_add/1","type":"macro"},{"doc":"Registers a handle triggering whenever a user deletes a reaction to a message.args : snowflake, snowflake, snowflake, %{&quot;animated&quot; =&gt; boolean, &quot;id&quot; =&gt; integer, &quot;name&quot; =&gt; String.t}Receives the id of the user that reacted/deleted, the channel_id where it happened, the message_id and the emoji","ref":"Alchemy.Events.html#on_reaction_remove/1","title":"Alchemy.Events.on_reaction_remove/1","type":"macro"},{"doc":"Registere a handle triggering whenever a user deletes all reactions to a message.args : snowflake, snowflakeReceives the channel_id and message_id","ref":"Alchemy.Events.html#on_reaction_remove_all/1","title":"Alchemy.Events.on_reaction_remove_all/1","type":"macro"},{"doc":"Registers a handle triggering whenever a shard receives a READY event.This event gets sent after a shard connects with the gateway, filling the cache with info about the guilds the bot is in.args : Integer, Integer Receives the shard number (starting at 0), and the total amount of shards.After this event has been received, most of the information in the cache should be failed.","ref":"Alchemy.Events.html#on_ready/1","title":"Alchemy.Events.on_ready/1","type":"macro"},{"doc":"Registers a handle triggering whenever a role gets created in a guild.args : Alchemy.Guild.role, snowflakeReceives the new role, as well as the id of the guild that it belongs to.","ref":"Alchemy.Events.html#on_role_create/1","title":"Alchemy.Events.on_role_create/1","type":"macro"},{"doc":"Registers a handle triggering whenever a role gets deleted from a guild.args : snowflake, snowflakeReceives the id of the role that was deleted, and the id of the guild it was deleted from.","ref":"Alchemy.Events.html#on_role_delete/1","title":"Alchemy.Events.on_role_delete/1","type":"macro"},{"doc":"Registers a handle triggering whenever a role gets updated in a guild.args : Alchemy.Guild.role, Alchemy.Guild.role, snowflakeReceives the old role, the new role and the id of the guild that it belongs to. The old role may be nil if it was not already cached when the event was received.","ref":"Alchemy.Events.html#on_role_update/1","title":"Alchemy.Events.on_role_update/1","type":"macro"},{"doc":"Registers a handle triggering whenever this user changes their settings.args : String.t, String.tReceives the username and avatar hash of the new settings.","ref":"Alchemy.Events.html#on_settings_update/1","title":"Alchemy.Events.on_settings_update/1","type":"macro"},{"doc":"Registers a handle triggering whenever a user starts typing in a channel.args : snowflake, snowflake, IntegerReceives the id of the user, the channel, and a timestamp (unix seconds) of the typing event.","ref":"Alchemy.Events.html#on_typing/1","title":"Alchemy.Events.on_typing/1","type":"macro"},{"doc":"Registers a handle triggering whenever a user gets banned from a guild.args : Alchemy.User.t, snowflake The user, as well as the id of the guild they were banned from get passed to the hook.ExampleEvents.on_user_ban(:cancel_ban) def cancel_ban(user, guild) do Client.unban_member(guild, user.id) end","ref":"Alchemy.Events.html#on_user_ban/1","title":"Alchemy.Events.on_user_ban/1","type":"macro"},{"doc":"Registers a handle triggering whenever a user gets unbanned from a guild.args : Alchemy.User.t, snowflake Recieves the user struct, as well as the id of the guild from which the user has been unbanned.ExamplesEvents.on_user_unban(:reban) def reban(user, guild) do Client.ban_member(guild_id, user.id) end","ref":"Alchemy.Events.html#on_user_unban/1","title":"Alchemy.Events.on_user_unban/1","type":"macro"},{"doc":"Registers a handle triggering whenever this user changes.args : Alchemy.User.tReceives the new information for this user.","ref":"Alchemy.Events.html#on_user_update/1","title":"Alchemy.Events.on_user_update/1","type":"macro"},{"doc":"Registers a handle triggering whenever someone leaves / joins a voice channel.args : Alchemy.Voice.stateReceives the corresponding voice state.","ref":"Alchemy.Events.html#on_voice_update/1","title":"Alchemy.Events.on_voice_update/1","type":"macro"},{"doc":"Unloads all the hooks in a module from the handler.If you just want to disable a single function from triggering, see Events.disable/1.ExamplesClient.start(@token) use MyEventsIf we want to remove this hooks at any point, we can simply doEvents.unload(MyEvents)And, to set hook the module back up, all we need to do is:use MyEvents","ref":"Alchemy.Events.html#unload/1","title":"Alchemy.Events.unload/1","type":"function"},{"doc":"Guilds represent a collection of users in a &quot;server&quot;. This module contains information about the types, and subtypes related to guilds, as well as some useful functions related to them.","ref":"Alchemy.Guild.html","title":"Alchemy.Guild","type":"module"},{"doc":"Finds the highest ranked role of a member in a guild.This is useful, because the permissions and color of the highest role are the ones that apply to that member.","ref":"Alchemy.Guild.html#highest_role/2","title":"Alchemy.Guild.highest_role/2","type":"function"},{"doc":"Get the icon image URL for the given guild. If the guild does not have any icon, returns nil.Parameterstype: The returned image format. Can be any of jpg, jpeg, png, or webp.size: The desired size of the returned image. Must be a power of two. If the parameters do not match these conditions, an ArgumentError is raised.","ref":"Alchemy.Guild.html#icon_url/3","title":"Alchemy.Guild.icon_url/3","type":"function"},{"doc":"Represents a custom emoji in a guild.The string representation of this struct will be the markdown necessary to use it. i.e. Cogs.say(&quot;\#{emoji}&quot;) will send the emoji.id The id of this emoji.name The name of this emoji.roles A list of role ids who can use this role.require_colons Whether or not this emoji must be wrapped in colons.managed Whether or not this emoji is managed.","ref":"Alchemy.Guild.html#t:emoji/0","title":"Alchemy.Guild.emoji/0","type":"type"},{"doc":"Represents an guild's integration with a service, (i.e. twitch)id The id of the integration.name The name of the integration.type Integration type; youtube, twitch, etc.enabled Whether or not the integration is enabled.syncing Whether or not the integration is syncing.role_id The id of the role associated with &quot;subscribers&quot; to this integration.expire_behaviour The behaviour of expiring subscribers.expire_grace_period The grace period before expiring subscribers.user The user for this integration.account The integration's account information.synced_at When this integration was last synced.","ref":"Alchemy.Guild.html#t:integration/0","title":"Alchemy.Guild.integration/0","type":"type"},{"doc":"Represents the account of an integration.id The id of the account.name The name of the account.","ref":"Alchemy.Guild.html#t:integration_account/0","title":"Alchemy.Guild.integration_account/0","type":"type"},{"doc":"Represents a member in a guild.user A user struct containing information about the underlying user.nick An optional nickname for this member.roles A list of ids corresponding to roles the member has.joined_at The timestamp of when this member joined the guild.deaf Whether the user is currently deafened.mute Whether the user is currently muted.","ref":"Alchemy.Guild.html#t:member/0","title":"Alchemy.Guild.member/0","type":"type"},{"doc":"Represents the presence of a user in a guild.user The user this presence is for.roles A list of role ids this user belongs to.game The current activity of the user, or nil.guild_id The id of the guild this presences is in.status &quot;idle&quot;, &quot;online&quot;, or &quot;offline&quot;","ref":"Alchemy.Guild.html#t:presence/0","title":"Alchemy.Guild.presence/0","type":"type"},{"doc":"Represents a role in a guild.id The id of the role.name The name of the role.color The color of the role.hoist Whether the role is &quot;hoisted&quot; above others in the sidebar.position The position of the role in a guild.permissions The bitset of permissions for this role. See the Permissions module for more information.managed Whether this role is managed by an integration.mentionable Whether this role is mentionable.","ref":"Alchemy.Guild.html#t:role/0","title":"Alchemy.Guild.role/0","type":"type"},{"doc":"","ref":"Alchemy.Guild.html#t:snowflake/0","title":"Alchemy.Guild.snowflake/0","type":"type"},{"doc":"Represents a guild.idThe id of this guild.nameThe name of this guild.icon The image hash of the icon image.splash The image hash of the splash image. Not a lot of guilds have a hash.owner_id The user id of the guild's owner.region The region of the guild.afk_channel_id The id of the afk channel, if the guild has one.afk_timeout The afk timeout in seconds.embed_enabled Whether this guild is embeddable.verification_level The level of verification this guild requires.default_message_notifications The default message notifications level.roles A list of the roles in this server.emojis A list of custom emojis in this server.features A list of guild features.mfa_level The required mfa level for the guild.The following fields will be missing for guilds accessed from outside the Cache:joined_at The timestamp of guild creation.large Whether or not this guild is considered &quot;large&quot;.unavailable This should never be true for guilds.member_count The number of members a guild contains.voice_states A list of voice states of the guild.members A list of members in the guild.channels A list of channels in the guild.presences A list of presences in the guild.","ref":"Alchemy.Guild.html#t:t/0","title":"Alchemy.Guild.t/0","type":"type"},{"doc":"An iso_8601 timestamp.","ref":"Alchemy.Guild.html#t:timestamp/0","title":"Alchemy.Guild.timestamp/0","type":"type"},{"doc":"This module contains the types and functions related to messages in discord.","ref":"Alchemy.Message.html","title":"Alchemy.Message","type":"module"},{"doc":"Finds a list of mentions in a string.4 types of mentions exist:roles A mention of a specific role.nicknames A mention of a user by nickname.users A mention of a user by name, or nickname.:channels A mention of a channel.","ref":"Alchemy.Message.html#find_mentions/2","title":"Alchemy.Message.find_mentions/2","type":"function"},{"doc":"Represents an emoji used to react to a message.id The id of this emoji. nil if this isn't a custom emoji.name The name of this emoji.","ref":"Alchemy.Message.html#t:emoji/0","title":"Alchemy.Message.emoji/0","type":"type"},{"doc":"","ref":"Alchemy.Message.html#t:mention_type/0","title":"Alchemy.Message.mention_type/0","type":"type"},{"doc":"Represents a reaction to a message.count Times this specific emoji reaction has been used.me Whether this client reacted to the message.emoji Information about the emoji used.","ref":"Alchemy.Message.html#t:reaction/0","title":"Alchemy.Message.reaction/0","type":"type"},{"doc":"","ref":"Alchemy.Message.html#t:snowflake/0","title":"Alchemy.Message.snowflake/0","type":"type"},{"doc":"Represents a message in a channel.id The id of this message.author The user who sent this message. This field will be very incomplete if the message originated from a webhook.content The content of the message.timestamp The timestamp of the message.edit_timestamp The timestamp of when this message was edited, if it ever was.tts Whether this was a tts message.mention_everyone Whether this message mentioned everyone.mentions A list of users this message mentioned.mention_roles A list of role ids this message mentioned.attachments A list of attachments to the message.embeds A list of embeds attached to this message.reactions A list of reactions to this message.nonce Used for validating a message was sent.pinned Whether this message is pinned.webhook_id The id of the webhook that sent this message, if it was sent by a webhook.","ref":"Alchemy.Message.html#t:t/0","title":"Alchemy.Message.t/0","type":"type"},{"doc":"Represents an iso8601 timestamp.","ref":"Alchemy.Message.html#t:timestamp/0","title":"Alchemy.Message.timestamp/0","type":"type"},{"doc":"This module contains useful functions for working for the permission bitsets discord provides.To combine the permissions of an overwrite with the permissions of a role, the bitwise ||| can be used.Example UsageCogs.def perms(role_name) do {:ok, guild} = Cogs.guild() role = hd Enum.filter(guild.roles, &amp; &amp;1.name == role_name) Cogs.say(inspect Permissions.to_list(role.permission)) endThis simple command prints out the list of permissions a role has avaiable.Permission List:create_instant_invite Allows the creation of instant invites.:kick_members Allows the kicking of members.:ban_members Allows the banning of members.:administrator Allows all permissions, and bypasses channel overwrites.:manage_channels Allows management and editing of channels.:manage_guild Allows management and editing of the guild.:add_reactions Allows adding reactions to message.:view_audit_log Allows for viewing of audit logs.:read_messages Allows reading messages in a channel. Without this, the user won't even see the channel.:send_messages Allows sending messages in a channel.:send_tts_messages Allows sending text to speech messages.:manage_messages Allows for deletion of other user messages.:embed_links Links sent with this permission will be embedded automatically:attach_files Allows the user to send files, and images:read_message_history Allows the user to read the message history of a channel:mention_everyone Allows the user to mention the special @everyone and @here tags:use_external_emojis Allows the user to use emojis from other servers.:connect Allows the user to connect to a voice channel.:speak Allows the user to speak in a voice channel.:mute_members Allows the user to mute members in a voice channel.:deafen_members Allows the user to deafen members in a voice channel.:move_members Allows the user to move members between voice channels.:use_vad Allows the user to use voice activity detection in a voice channel:change_nickname Allows the user to change his own nickname.:manage_nicknames Allows for modification of other user nicknames.:manage_roles Allows for management and editing of roles.:manage_webhooks Allows for management and editing of webhooks.:manage_emojis Allows for management and editing of emojis.","ref":"Alchemy.Permissions.html","title":"Alchemy.Permissions","type":"module"},{"doc":"Gets the actual permissions of a member in a guild channel.This will error if the channel_id passed isn't in the guild. This will mismatch if the wrong structs are passed, or if the guild doesn't have a channel field.","ref":"Alchemy.Permissions.html#channel_permissions/3","title":"Alchemy.Permissions.channel_permissions/3","type":"function"},{"doc":"Banged version of channel_permissions/3","ref":"Alchemy.Permissions.html#channel_permissions!/3","title":"Alchemy.Permissions.channel_permissions!/3","type":"function"},{"doc":"Checks for the presence of a permission in a permission bitset.This should be preferred over using :perm in Permissions.to_list(x) because this works directly using bitwise operations, and is much more efficient then going through the permissions.ExamplesPermissions.contains?(role.permissions, :manage_roles)","ref":"Alchemy.Permissions.html#contains?/2","title":"Alchemy.Permissions.contains?/2","type":"function"},{"doc":"Converts a list of permission atoms into a bitset. This is the reverse operation of to_list/1.Examplesbitset = Permissions.to_bitset([:send_messages, :speak])","ref":"Alchemy.Permissions.html#to_bitset/1","title":"Alchemy.Permissions.to_bitset/1","type":"function"},{"doc":"Converts a permission bitset into a legible list of atoms. This is the reverse operation of to_bitset/1.For checking if a specific permission is in that list, use contains?/2 instead.Examplespermissions = Permissions.to_list(role.permissions)","ref":"Alchemy.Permissions.html#to_list/1","title":"Alchemy.Permissions.to_list/1","type":"function"},{"doc":"","ref":"Alchemy.Permissions.html#t:permission/0","title":"Alchemy.Permissions.permission/0","type":"type"},{"doc":"This module contains functions and types related to discord users.","ref":"Alchemy.User.html","title":"Alchemy.User","type":"module"},{"doc":"Used to get the url for a user's avatartype must be one of &quot;png&quot;, &quot;webp&quot;, &quot;jpg&quot;, &quot;gif&quot;size must be one of 128, 256, 512, 1024, 2048Examples&gt; User.avatar_url(user) https://cdn.discordapp.com/avatars/...","ref":"Alchemy.User.html#avatar_url/1","title":"Alchemy.User.avatar_url/1","type":"function"},{"doc":"","ref":"Alchemy.User.html#avatar_url/3","title":"Alchemy.User.avatar_url/3","type":"function"},{"doc":"Returns a string that mentions a user when used in a message","ref":"Alchemy.User.html#mention/1","title":"Alchemy.User.mention/1","type":"function"},{"doc":"","ref":"Alchemy.User.html#t:snowflake/0","title":"Alchemy.User.snowflake/0","type":"type"},{"doc":"Represents a discord User. The default values exist to cover missing fields.idrepresents a unique user idusernamerepresents a user's current usernamediscriminator4 digit tag to differenciate usernamesavatarA string representing their avatar hash. Use avatar_url to get the corresponding url from a User objectbotWhether or not the user is a bot - default: falseA bot usually doesn't have the authorization necessary to access these 2, so they're usually missing.verifiedWhether the account is verified - default: :hiddenemailThe user's email - default: :hidden","ref":"Alchemy.User.html#t:t/0","title":"Alchemy.User.t/0","type":"type"},{"doc":"","ref":"Alchemy.User.html#t:token/0","title":"Alchemy.User.token/0","type":"type"},{"doc":"","ref":"Alchemy.User.html#t:url/0","title":"Alchemy.User.url/0","type":"type"},{"doc":"A shortened version of a Guild struct, through the view of a User.idRepresents the guild's id.nameRepresents the guild's name.iconA string representing the guild's icon hash.ownerWhether the user linked to the guild owns it.permissionsBitwise of the user's enabled/disabled permissions.","ref":"Alchemy.User.html#t:user_guild/0","title":"Alchemy.User.user_guild/0","type":"type"},{"doc":"Contains the types and functions related to voice communication with discord.To use the functions in this module, make sure to configure the paths to ffmpeg, as well as youtube-dl, like so:config :alchemy, ffmpeg_path: &quot;path/to/ffmpeg&quot; youtube_dl_path: &quot;path/to/youtube-dl&quot;If these are not configured, the necessary supervisors for maintaining voice connections won't be started, and you'll run into errors when trying to use the functions in this module.","ref":"Alchemy.Voice.html","title":"Alchemy.Voice","type":"module"},{"doc":"Joins a voice channel in a guild.Only one voice connection per guild is possible with the api. If you're already connected to the guild, this will not restart the voice connections, but instead just move you to the channel.This function also checks if you're already connected to this channel, and does nothing if that is the case.The timeout will be spread across 2 different message receptions, i.e. a timeout of 6000 will only wait 3s at every reception.","ref":"Alchemy.Voice.html#join/3","title":"Alchemy.Voice.join/3","type":"function"},{"doc":"Disconnects from voice in a guild.Returns an error if the connection hadn’t been established.","ref":"Alchemy.Voice.html#leave/1","title":"Alchemy.Voice.leave/1","type":"function"},{"doc":"Lets this process listen for the end of an audio track in a guild.This will subscribe this process up until the next time an audio track ends, to react to this, you'll want to handle the message in some way, e.g.Voice.listen_for_end(guild) receive do {:audio_stopped, ^guild} -&gt; IO.puts &quot;audio has stopped&quot; endThis is mainly designed for use in genservers, or other places where you don't want to block. If you do want to block and wait immediately, try wait_for_end/2 instead.ExamplesUse in a genserver:def handle_info({:audio_stopped, guild}, state) do IO.puts &quot;audio has stopped in \#{guild}&quot; Voice.listen_for_end(guild) {:noreply, state} end","ref":"Alchemy.Voice.html#listen_for_end/1","title":"Alchemy.Voice.listen_for_end/1","type":"function"},{"doc":"Starts playing a music file on a guild's voice connection.Returns an error if the client isn't connected to the guild, or if the file does not exist.ExamplesVoice.join(&quot;666&quot;, &quot;666&quot;) Voice.play_file(&quot;666&quot;, &quot;cool_song.mp3&quot;)","ref":"Alchemy.Voice.html#play_file/3","title":"Alchemy.Voice.play_file/3","type":"function"},{"doc":"Starts playing audio from an iodata, or a stream of iodata.Similar to play_url/2 except it doesn't create a stream from youtube-dl for you.","ref":"Alchemy.Voice.html#play_iodata/3","title":"Alchemy.Voice.play_iodata/3","type":"function"},{"doc":"Starts playing audio from a url.For this to work, the url must be one of the supported sites. This function does not check the validity of this url, so if it's invalid, an error will get logged, and no audio will be played.","ref":"Alchemy.Voice.html#play_url/3","title":"Alchemy.Voice.play_url/3","type":"function"},{"doc":"Stops playing audio on a guild's voice connection.Returns an error if the connection hadn't been established.","ref":"Alchemy.Voice.html#stop_audio/1","title":"Alchemy.Voice.stop_audio/1","type":"function"},{"doc":"Blocks the current process until audio has stopped playing in a guild.This is a combination of listen_for_end/1 and a receive block, however this will return an error if the provided timeout is exceeded. This is useful for implementing automatic track listing, e.g.def playlist(guild, tracks) do Enum.map(tracks, fn track -&gt; Voice.play_file(guild, track) Voice.wait_for_end(guild) end) end","ref":"Alchemy.Voice.html#wait_for_end/2","title":"Alchemy.Voice.wait_for_end/2","type":"function"},{"doc":"Returns which channel the client is connected to in a guild.Returns nil if there is no connection.","ref":"Alchemy.Voice.html#which_channel/1","title":"Alchemy.Voice.which_channel/1","type":"function"},{"doc":"Represents the audio options that can be passed to different play methods. Optionsvol audio volume, in %. Can go above 100 to multiply, e.g. 150.","ref":"Alchemy.Voice.html#t:audio_options/0","title":"Alchemy.Voice.audio_options/0","type":"type"},{"doc":"Represents a voice region.id Represent the unique ID for this region.name The name of this region.sample_hostname An example hostname for the region.sample_port An example port for the region.vip True if this is a vip-only server.optimal True for a single server that is closest to the client.deprecated Whether this is a deprecated voice region.custom Whether this is a custom voice region.","ref":"Alchemy.Voice.html#t:region/0","title":"Alchemy.Voice.region/0","type":"type"},{"doc":"","ref":"Alchemy.Voice.html#t:snowflake/0","title":"Alchemy.Voice.snowflake/0","type":"type"},{"doc":"Represents the state of a user's voice connection.guild_id The guild id this state is for.channel_id The channel id this user is connected to.user_id The id of the user this state belongs to.session_id The session id for this voice state.deaf Whether this user is deafened by the server.mute Whether this user is muted by the server.self_deaf Whether this user is locally deafened.self_mute Whether this user is locally muted.suppress Whether this user is muted by the current user.","ref":"Alchemy.Voice.html#t:state/0","title":"Alchemy.Voice.state/0","type":"type"},{"doc":"","ref":"Alchemy.Webhook.html","title":"Alchemy.Webhook","type":"module"},{"doc":"Creates a new webhook in a channel.The name parameter is mandatory, and specifies the name of the webhook. of course.Optionsavatar A link to a 128x128 image to act as the avatar of the webhook.Examples{:ok, hook} = Webhook.create(&quot;66666&quot;, &quot;The Devil&quot;)","ref":"Alchemy.Webhook.html#create/3","title":"Alchemy.Webhook.create/3","type":"function"},{"doc":"Deletes a webhook.All you need for this is the webhook itself.Examples{:ok, wh} = Webhook.create(&quot;666&quot;, &quot;Captain Hook&quot;) Webhook.delete(wh)","ref":"Alchemy.Webhook.html#delete/1","title":"Alchemy.Webhook.delete/1","type":"function"},{"doc":"Modifies the settings of a webhook.Note that the user field of the webhook will be missing.Optionsname The name of the webhook.avatar A link to a 128x128 icon image.Examples{:ok, hook} = Webhook.create(&quot;6666&quot;, &quot;Captian Hook&quot;) # Let&#39;s fix that typo: Webhook.edit(hook, name: &quot;Captain Hook&quot;)","ref":"Alchemy.Webhook.html#edit/2","title":"Alchemy.Webhook.edit/2","type":"function"},{"doc":"Returns a list of all webhooks in a channel.Examples{:ok, [%Webhook{} | _]} = Webhook.in_channel(&quot;6666&quot;)","ref":"Alchemy.Webhook.html#in_channel/1","title":"Alchemy.Webhook.in_channel/1","type":"function"},{"doc":"Returns a list of all webhooks in a guild.Examples{:ok, [%Webhook{} | _]} = Webhook.in_guild(&quot;99999&quot;)","ref":"Alchemy.Webhook.html#in_guild/1","title":"Alchemy.Webhook.in_guild/1","type":"function"},{"doc":"Sends a message to a webhook.type must be one of :embed, :content; :embed requiring an Embed.t struct, and :content requiring a string.Optionsavatar_url A link to an image to replace the one the hook has, for this message.username The username to override to hook's, for this message.tts When set to true, will make the message TTSExamples{:ok, hook} = Webhook.create(&quot;66&quot;, &quot;Captain Hook&quot;) Webhook.send(hook, {content: &quot;ARRRRRGH!&quot;})For a more elaborate example:user = Cache.user() embed = %Embed{} |&gt; description(&quot;I&#39;m commandeering this vessel!!!&quot;) |&gt; color(0x3a83b8) Webhook.send(hook, {:embed, embed}, avatar_url: User.avatar_url(user), username: user.username)","ref":"Alchemy.Webhook.html#send/3","title":"Alchemy.Webhook.send/3","type":"function"},{"doc":"","ref":"Alchemy.Webhook.html#t:snowflake/0","title":"Alchemy.Webhook.snowflake/0","type":"type"},{"doc":"","ref":"Alchemy.Webhook.html#t:t/0","title":"Alchemy.Webhook.t/0","type":"type"},{"doc":"","ref":"Mix.Tasks.Alchemy.Init.html","title":"Mix.Tasks.Alchemy.Init","type":"task"},{"doc":"","ref":"Mix.Tasks.Alchemy.Init.html#run/1","title":"Mix.Tasks.Alchemy.Init.run/1","type":"function"},{"doc":"Getting StartedAfter installing your dependencies and whatnot, it's time to write your bot! (If you just want a template to work from, you can use mix alchemy.init to generate one quickly.)The first thing we need to do is define some kind of application for our bot. Thankfully, the Application module encapsulates this need.defmodule MyBot do use Application alias Alchemy.Client def start(_type, _args) do Client.start(&quot;your token here&quot;) end endThe Client.start/2 function sets up the necessary client connections to discord; because of this, not much can really be done before this function is called.At this point, we have our bot running, but it does nothing! Let's add a command:defmodule MyBot.Commands do use Alchemy.Cogs Cogs.def ping do Cogs.say &quot;pong!&quot; end endThe first thing we do in this module is use Alchemy.Cogs this sets up our module to be able to define commands, which we can later plug into our bot. We use the Cogs.def macro to define a command; command definition is very similar to commands, in fact, pattern matching and guards still work just as they would in normal functions, and in fact, they're very useful in writing useful commands! This command will get triggered anytime a user types !ping in the chat. We can also change the command prefix using Cogs.set_prefix/1. In the command itself, we simply send a message back to the same channel with Cogs.say, and that's it!Loading a CogNow to load the Cog into our application, all we need to do is use it:def start(_type, _args) do run = Client.start(&quot;your token here&quot;) use MyBot.Commands run endThis will load up all the commands we defined in the module, and make them ready to use. We can also do this dynamically from the repl, use Module will work there as well. If at any time we want to unload a module, Cogs.unload/1 is quite handy. If we just need to disable a single command, Cogs.disable/1 is also useful.Adding the application to our mixNow all we need to do to wire up this application, is to add it to our mix.exs:def application do [mod: {Mybot, []}] endThis makes our bot automatically start when we run our project.Running our applicationNow, to run this project, we have 2 options:use mix run --no-halt (the flags being necessary to prevent the app from ending once our start/2 function finishes)or use iex -S mix to start our application in the repl.Starting the application in the repl is very advantageous, as it allows you to interact with the bot live.Using VoiceAlchemy also supports using discord's voice API to play audio. We rely on ffmpeg for audio encoding, as well as youtube-dl for streaming audio from sites. Before the voice api can be used, you'll need to acquire the latest versions of those from their sites (make sure you get ffmpeg with opus support), and then configure the path to those executables in alchemy like so:# in config.exs config :alchemy, ffmpeg_path: &quot;path/to/ffmpeg&quot;, youtube_dl_path: &quot;path/to/youtube_dl&quot;Now you're all set to start playing some audio!The first step is to connect to a voice channel with Alchemy.Voice.join/2, then, you can start playing audio with Alchemy.Voice.play_file/2, or Alchemy.Voice.play_url/2. Here's an example command to show off these features:Cogs.def play(url) do {:ok, id} = Cogs.guild_id() # joins the default channel for this guild # this will check if a connection already exists for you Voice.join(id, id) Voice.play_url(id, url) Cogs.say &quot;Now playing \#{url}&quot; endWhere to go nowI'd recommend taking a look at the Alchemy.Cogs module for more examples of defining commands, and how to make use of pattern matching in them.If you want to learn about event hooks, check out the Alchemy.Events module.If you want to dig through the many api functions available, check out Alchemy.Client.","ref":"intro.html","title":"Getting Started","type":"extras"}]